#include<iostream>
#include<algorithm>
#include<vector>
#define MAXN 50000
#define MAXLOG 17
using namespace std;
vector <pair <int, int> > teleports;
pair <int, int> diffs[MAXN];
vector <pair <int, int> > order;
int gcd[MAXN];
int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    int n,q;
    cin >> n >> q ;
    teleports.resize(n);
    for (int i=0; i<n; i++) {
        cin >> teleports[i].second ;
    }
    for (int i=0; i<n; i++) {
        cin >> teleports[i].first ;
    }
    sort(teleports.begin(),teleports.end());
    for (int i=0; i<n-1; i++) {
        diffs[i].first=teleports[i+1].first-teleports[i].first;
        diffs[i].second=teleports[i+1].second-teleports[i].second;
    }
    sort(diffs,diffs+n-1);
    gcd[0]=diffs[0].second;
    for (int i=1; i<n-1; i++) {
        auto [df, dc]=diffs[i];
        gcd[i]=__gcd(gcd[i-1],dc);
    }
    int a,b,lf,rf;
    for (int i=0; i<q; i++) {
        cin >> a >> b >> lf >> rf ;
        int l=-1,r=n-1,mid;
        for (;;) {
            if (l==r-1) break;
            mid=(l+r)/2;
            if ((gcd[mid]!=0)&&((b-a)%(2LL*gcd[mid])==0)) r=mid;
            else l=mid;
        }
        if (r==n-1) {
            cout << -1 << " ";
            continue;
        }
        cout << diffs[r].first << " ";
    }
    cout << endl ;
    return 0;
}
